-- TRR Exporter
--  Version 0.0.3
--  by machf
--  Copyright  TresCom, 2017

-- Version History:
-- 0.0.1
--  * converted from TPM Exporter 1.2.4y
-- 0.0.2
--  * renamed function to prevent conflicts with TPM Exporter 1.2.4y
-- 0.0.3
--  * added floor() function to prevent errors with GUIapp

-- clean up
clearlistener()

-- options
global opt_scalefix = false

-- material redundancy list
global matlist = #()
global matlistnum = 0

-- warnings
global warn_notobj = false
global warn_mirror = false
global warn_twoside = false

-- write mesh
fn WriteTrrMesh obj =
(
 local op = obj.objectoffsetpos
 local os = obj.scale
 
 local isskin = false
 local boneVerts = #()
 local i
 local k
 
 -- write vertices
 local v
 for i=1 to obj.numverts do
 (
  in coordsys world v = (getvert obj i)
  
--    if v.z > 0 then
--    (
      format "% % %\n" (floor ( v.x + 0.0005 )) (floor ( v.y + 0.0005 )) v.z
--    ) else (
--      format "% % %\n" (floor ( v.x + 0.0005 )) (floor ( v.y + 0.0005 )) 0.0
--    )
 )
 
 
 -- clean up
 fnlist = #()
 
)


utility TrrExp "TRR Exporter"
(
 group "About"
 (
  label lab1 "TRR Exporter"
  label lab2 "Version 0.0.3"
  label lab4 "Modified by M.A.Ch.F."
  label lab5 "Copyright  TresCom, 2017"
 )
 group "Export"
 (
  checkbox chkSelected "Selection Only" checked: true
  button cmdExport "Export Terrain..." width: 140
 )
 on cmdExport pressed do
 (
  local j
  local b
  
  -- reset material redundancy list
  matlist = #()
  matlistnum = 0
  
  -- reset warning flags
  warn_notobj = false
  warn_mirror = false
  warn_twoside = false
  
  -- write objects
  local obj
  for j=1 to $objects.count do
  (
   obj = $objects[j]
  
   -- skip unselected
   if chkSelected.checked == true do
   (
    if not obj.isSelected do continue
   )
   
   -- write data block
     WriteTrrMesh obj
   
  )
  
  -- clean up material redundancy list
  matlist = #()
  matlistnum = 0
  
  -- warnings
  local errstr = ""
  if warn_notobj do  errstr = errstr + "* not all scene objects could be exported\n"
  if warn_mirror do  errstr = errstr + "* some objects are mirrored, this may lead to object orientation problems\n"
  if warn_twoside do errstr = errstr + "* some materials are two sided, these are not preserved\n"
  if errstr.count > 0 do messagebox ("Warning:\n" + errstr)
   
  -- success confirmation
  messagebox "Terrain exported successfully."
  
 )
)



-- END OF FILE


